/*-----------------------------------------------------------------
 ਭ ..

樮 ࠬ  -  2

  ᠭ
䠩 demo.h
ࠧࠡ⪠ 2000 
------------------------------------------------------------------*/

typedef unsigned char uchar;
typedef unsigned int uint;
typedef unsigned long ulong;

//   ᮮ饭  訡
#define NO_ERR 0
#define ERR_OTL 1
#define ERR_PUST 2
#define ERR_KSUM 10
#define ERR_NOOPENSF 11
#define ERR_EXT 12
#define ERR_NETOTVET 13
#define ERR_PUSTGR 14
#define ERR_FILE 15
#define ERR_ODINAK_KOORD 16
#define ERR_ADR 17
#define ERR_DLINA 18
#define ERR_NOTMR 19
#define ERR_NOPRER 20
#define ERR_NOINIT 21
#define ERR_NOPRDKLS 22
#define ERR_NOPRMKLS 23
#define ERR_LINIA 24
#define ERR_NEPRREZ 25


//-------------------------------------------------------------
// ⨯ 㭪権 䠩 Zki.cpp

void checkZki ( void );
void kadrZki ( int nKadr );
void puskZki ();
void stopZki ();

//-------------------------------------------------------------
// ⨯ 㭪権 䠩 Ext.cpp

void init15 ();

uint CtenExtV ( ulong adr, void *znc, uint dlina );
uint ZapisExtV ( ulong adr, void *znc, uint dlina );

uint CtenExt ( ulong adr, uint *znc );
uint ZapisExt ( ulong adr, uint znc );

uint CtenMdk ( ulong adr, uint *znc );
uint ZapisMdk ( ulong adr, uint znc );

//-------------------------------------------------------------
// ⨯ 㭪権 䠩 Tmr.cpp

void initTimer ();
void stopTimer ();
void interrupt funTimer (...);
extern float tekWrem;

void avtKren ( uint znac );

//-------------------------------------------------------------
// ⨯ 㭪権 䠩 Plan.cpp

void plan ();

/*-----------------------------------------------------------------
 ਭ ..

樮 ࠬ  -  2

㭪樨 ⢨  -34
䠩 mww.h
 ।
ࠧࠡ⪠ 2000 
------------------------------------------------------------------*/

//   寮୮  -34
#define BASADR 0xa00000l

//  㦥 ᫮  ୮ 
#define ADR_MAS_NASTR 0x40;
#define SL_ISPR_TIP 0x7ff0
#define SL_ISPR_ADR 0x7ff2
#define SL_ISPR_PAR1 0x7ff4
#define SL_ISPR_PAR2 0x7ff6
#define SL_TMR1 0x7ff8
#define SL_TMR2 0x7ffa
#define SL_SOST 0x7ffc
#define SL_UPR 0x7ffe

// ࠧ ࠢ饣 ᫮  ᫮ ﭨ
#define SS_REZIM 0x1f00
#define SS_OBMEN 0
#define SS_OZIDANIE 0x100
#define SS_INIT 0x200
#define SS_RASKON 0x400
#define SS_KPP 0x800
#define SS_KONTOBM 0x1000

#define SS_NI_MWW 0x8000
#define SS_NI_OBM 0x4000

//    ᨣ
struct TSign
{
public:
uchar adrKls;
uchar kanal;
float csr;
};
#define LEN_SIGN 6

//    㯯 ᨣ
struct TGrSign
{
uchar prd;
uchar ss;
uint period;
uint kolvo;
uint adrZnac;
uint adrMatr;
uint adrFlag;
//struct TSign sign [];
//ulong ksum;
};
#define LEN_GR 12
#define LEN_KS 4

#define SF_STORTMR 7

// 㭪樨 䠩 InitMww.cpp

uint RezimMww ( uint trebRezim );
uint OzidanieOtvetaMww ( uint trebRezim, uint timeout );

uint StorozTmrMww ();
uint InitObmenMww ();
void interrupt ObrabotkaPrerMww (...);

uint FormBdMww ();
uint ZaprosBdRucn ();
uint ZaprosGrSign ( struct TGrSign* gr );
uint ZaprosSign ( struct TSign* sg );
ulong KonSum ( void* gr, uint len );

// 㭪樨 䠩 ObmenMww.cpp

uint OpenSf ( uint nSf );
uint CloseSf ( uint nSf );
uint ZapisMwwInt ( uint nSf, uint adr, uint znc );
uint CtenMwwInt ( uint nSf, uint adr, uint* znc );
uint ZapisMwwLng ( uint nSf, uint adr, ulong znc );
uint CtenMwwLng ( uint nSf, uint adr, ulong* znc );

char* ImaRezimMww ( uint rezim );
char* ImaErr ( uint err );

uint ObmenMww ( uint zncZap );
uint StorozTmrMww ();

// 㭪樨 䠩 KontMww.cpp

uint KontMww ();
uint RasKont ();

/*-----------------------------------------------------------------
 ਭ ..

樮 ࠬ  -  2

 㭪
䠩 demo.cpp
ࠧࠡ⪠ 2000 
------------------------------------------------------------------*/


void main ()
{

int far *ptr;
unsigned int asciiKod;
int flagWih = 0;

ptr=(int far *)0x417L;
*ptr=0;

ZapisMdk ( 0xD03F0110L, 0x1234 );
ZapisMdk ( 0xD03F0100L, 0x5678 );

printf ( "樮 ணࠬ \n\rQ - 室\n\r" );
puskZki ();
atexit ( stopZki );
kadrZki ( 36 );
ishodnoe ();
checkZki ();
ZapisMdk ( 0xD03F0110L, 0x1234 );
ZapisMdk ( 0xD03F0100L, 0x5678 );

InitObmenMww ();
initTimer ();

while ( ! flagWih )
  {
  asciiKod = bioskey ( 0 );
  if ( asciiKod & 0xFF ) asciiKod &= 0x00FF;
  switch ( asciiKod )
	{
	case 'q' : flagWih = 1; break;
	case SPK1 : invers ( 0x0d0300030, 0x10 ); break;
	case SPK2 : izmZvet (); break;
	case SPK3 : invers ( 0x0d0300030, 0x4 ); break;
	case SPK4 : invers ( 0x0d0300030, 0x2 ); break;
	case SPK5 : invers ( 0x0d0300030, 0x80 ); break;
	case SLK5 :	ishodnoe (); break;
	case SLK4 : nacWwodKren (); break;
	case 0x4900 :  plan ();	  kadrZki ( 36 ); ishodnoe ();
	  break;
	default :wwodKren ( asciiKod );
	  break;
	}
  checkZki ();
  }
stopTimer ();
}

/*-----------------------------------------------------------------
 䮭 .., ਭ ..

樮 ணࠬ  -  2

㭪樨 ࠡ  ७ 
䠩 Ext.cpp
ࠧࠡ⪠ 2000 
------------------------------------------------------------------*/
#include "demo.h"

#include <stdio.h>
#include <conio.h>
#include <string.h>
#include <dos.h>
#include <stdlib.h>
#include <ctype.h>
#include <bios.h>

const RGA = 0x340;                    //  楫 

/*   ।   Int 15h  */
struct SREGS segs;
struct
  {
  unsigned char dummi[8];
  unsigned char this_gdt[8];
  unsigned int source_limit;
  unsigned int src_lo;
  unsigned char src_hig;
  unsigned char source_acces;
  unsigned int source_reserved;
  unsigned int dest_limit;
  unsigned int dest_lo;
  unsigned char dest_hig;
  unsigned char dest_acces;
  unsigned int dest_reserved;
  unsigned char code_seg_bios[8];
  unsigned char stack_seg_bios[8];
  }
int_15_gdt;

union REGS reg;

unsigned int starAdr = 0;            //  ஢ RGA

void init15 ()
{
starAdr = 0;

/* 樠 ﭭ    Int 15h */
int i;
for ( i=0; i<8; i++ ) int_15_gdt.dummi[i] = 0;
for ( i=0; i<8; i++ ) int_15_gdt.this_gdt[i] = 0;
int_15_gdt.source_acces = 0x93;
int_15_gdt.source_reserved = 0;
int_15_gdt.dest_acces = 0x93;
int_15_gdt.dest_reserved = 0;
for (i=0; i<8; i++) int_15_gdt.code_seg_bios[i] = 0;
for (i=0; i<8; i++) int_15_gdt.stack_seg_bios[i] = 0;
}

uint CtenExtV ( ulong adr, void* znc, uint dlina )
{
init15 ();
int_15_gdt.src_hig = adr >> 16;
int_15_gdt.src_lo = (uint) adr;
int_15_gdt.source_limit = dlina;
int_15_gdt.dest_limit = dlina;

ulong adrTek = FP_SEG ( znc );
adrTek <<= 4;
adrTek += FP_OFF ( znc );
int_15_gdt.dest_lo = ( uint )( adrTek & 0x0ffff );
int_15_gdt.dest_hig = adrTek >> 16;

reg.x.ax = 0x8700;          // SubFn= 0x87;
reg.x.cx = dlina >> 1;  //              // 1 ᫮  16 pp冷
segread ( &segs );
_ES = _DS;
reg.x.si = (unsigned int) & int_15_gdt;
int86 ( 0x15, &reg, &reg );

if ( reg.h.ah ) return ERR_EXT;  // reg.h.ah =  0  OK !!!
else return NO_ERR;               //        != 0  ERROR
}

uint ZapisExtV ( ulong adr, void* znc, uint dlina )
{
init15 ();

ulong adrTek = FP_SEG ( znc );
adrTek <<= 4;
adrTek += FP_OFF ( znc );
int_15_gdt.src_lo = ( uint )( adrTek & 0x0ffff );
int_15_gdt.src_hig = adrTek >> 16;

int_15_gdt.dest_hig= adr >> 16;
int_15_gdt.dest_lo= (uint) adr;

reg.x.ax= 0x8700;          // SubFn= 0x87;
reg.x.cx= dlina >> 1;               // 1 ᫮  16 pp冷
segread(&segs);
_ES = _DS;
reg.x.si= (unsigned int)& int_15_gdt;
int86 ( 0x15, &reg, &reg);

if (reg.h.ah) return ERR_EXT;  // reg.h.ah =  0  OK !!!
else return NO_ERR;           //          != 0  ERROR
}

//------------------------------------------------------------

uint CtenExt ( ulong adr, uint *znc )
{
return CtenExtV ( adr, znc, 2 );
}

uint ZapisExt ( ulong adr, uint znc )
{
return ZapisExtV ( adr, &znc, 2 );
}

//------------------------------------------------------------

ulong adrMdk ( ulong adr )
{
uint a = (uint)( adr >> 18 );   // ᫥ RGA
if ( a != starAdr )                      // ᫨   ࠢ ஬
  outport ( 0x340, a );     // 
starAdr = a;
adr >>= 3;                    // ᫥ ᬥ饭
adr &= 0x00007fffl;               //  
adr += 0x00800000l;
return adr;
}

uint CtenMdk ( ulong adr, uint *znc )
{
return CtenExt ( adrMdk ( adr), znc );
}

uint ZapisMdk ( ulong adr, uint znc )
{
return ZapisExt ( adrMdk ( adr ), znc );
}

/*-----------------------------------------------------------------
 䮭 .., ਭ ..

樮 ணࠬ  -  2

㭪樨 뢮   १ 
䠩 Zki.cpp
ࠧࠡ⪠ 2000 
------------------------------------------------------------------*/
#include"demo.h"

#include <stdio.h>
#include <conio.h>
#include <string.h>
#include <dos.h>
#include <stdlib.h>
#include <ctype.h>
#include <bios.h>

unsigned int volatile Kdr = 0;

/* ⠭    ஢મ ⮢ */
void checkZki ()
{
uint w,w2,i;

CtenMdk ( 0xD0300000L, &w );
CtenMdk ( 0xD0300000L, &w );

CtenMdk ( 0xD0300010L, &w2 );
w2 &= 0x0FE00;
w2 += Kdr;

asm cli
ZapisMdk ( 0xD0300010L, w2 );
ZapisMdk ( 0xD0300000L, 0 );
for ( i = 0; i < 100; i++ )
  {
  delay (15 );
  CtenMdk ( 0xD0300000L, &w );
  CtenMdk ( 0xD0300000L, &w );

  CtenMdk ( 0xD0300010L, &w2 );
  if ( ( !w ) && ( !( w2 & 0x1FF )))
	{
	asm sti
	delay(20);
	return;
	}
  }
asm sti
printf("\r\n ⮢ !\r\n");
exit ( 0 );
}

//==================================================================

void kadrZki ( int nKadr )
{
if ( nKadr == 499 )
  {
  ZapisMdk ( 0xD0300050L, 0 );
  ZapisMdk ( 0xD0300040L, 0 );
  }
Kdr = nKadr;
checkZki ();
}

void puskZki ()
{
uint v100,v110;
init15 ();
CtenMdk ( 0xC0000100L, &v100 );
CtenMdk ( 0xC0000100L, &v100 );
CtenMdk ( 0xC0000110L, &v110 );

ZapisMdk ( 0xC0000110L, v110 );
ZapisMdk ( 0xC0000100L, 0 );
ZapisMdk ( 0xC00000D0L, 0 );
ZapisMdk ( 0xC00000C0L, 3 );
ZapisMdk ( 0xD0300030L, 0 );
ZapisMdk ( 0xD0300020L, 356 );
delay ( 50 );
Kdr = 0;
checkZki ();
}

void stopZki ( void )
{
uint v100,v110;

Kdr=0x1FF;
checkZki();

CtenMdk ( 0xC0000100L, &v100 );
CtenMdk ( 0xC0000100L, &v100 );
CtenMdk ( 0xC0000110L, &v110 );

ZapisMdk(0xC0000110L, v110 );
ZapisMdk(0xC0000100L,0xC000);
}

/*-----------------------------------------------------------------
 ਭ ..

樮 ࠬ  -  2

㭪樨 ॠ樨  "騥 ⠭"
䠩 demo.cpp
ࠧࠡ⪠ 2000 
------------------------------------------------------------------*/
#include <dos.h>
#include <bios.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "demo.h"
#include "mww.h"

#define SLK1 0x3b00
#define SPK1 0x3c00
#define SLK2 0x3d00
#define SPK2 0x3e00
#define SLK3 0x3f00
#define SPK3 0x4000
#define SLK4 0x4100
#define SPK4 0x4200
#define SLK5 0x4300
#define SPK5 0x4400
#define SLK6 0x29
#define SPK6 0x56
#define PLANN 0x4900

//------------------------------------------------

#define kolSim 3

int volatile rezimWwod = 0;
char bufSim [ kolSim ];
int nSim = 0;

void wiwodTekZnc ()
{
if ( ! bufSim [ 1 ] )
  {
  bufSim [ 1 ] = ' ';
  bufSim [ 2 ] = 0;
  }

ZapisMdk ( 0x0d0300070, 0 );
ZapisMdk ( 0x0d0300060, (uint)((bufSim[1]<<8)+bufSim[0] ));
}

void kursor ( int x, int y, int rezRed )
{
uint znc20, znc30;
CtenMdk ( 0x0d0300020, &znc20 );
CtenMdk ( 0x0d0300030, &znc30 );
znc30 &=0xFEFF; //   
znc20 &=0xFE00;
znc20 += y * 24 + x;
if ( rezRed ) znc20 |= 0x200;
else znc20 &= 0xfdff;
ZapisMdk ( 0x0d0300030, znc30 );
ZapisMdk ( 0x0d0300020, znc20 );
}

void nacWwodKren ()
{
int i;
rezimWwod = 1;
for ( i = 0; i < kolSim; i++ ) bufSim [ i ] = ' ';
nSim = 0;
kursor ( 4 + nSim, 8, 1 );
wiwodTekZnc ();
}

void konWwodKren ()
{
rezimWwod = 0;
kursor ( 6, 14, 0 );
//ZapisMwwInt ( 2, atoi ( bufSim ));
}

void zaboy ()
{
if ( nSim > 0 )
  {
  nSim--;
  bufSim [ nSim ] = 0;
  }
kursor ( 4 + nSim, 8, 1 );
wiwodTekZnc ();
}

void wwodKren ( int kod )
{
if ( ! rezimWwod ) return;
switch ( kod )
  {
  case 27: nacWwodKren (); return;  // esc
  case 13: konWwodKren (); return;  // ww
  case 8: zaboy (); return;    // st
  }
if ((( kod >= '0') && ( kod <= '9')) || ( kod == '.'))
  {
  if ( nSim >= kolSim - 1 )
	{
	printf ( "९  \n\r" );
	return;
	}
  bufSim [ nSim ++ ] = kod;
  kursor ( 4 + nSim, 8, 1 );
  wiwodTekZnc ();
  }
}

void avtKren ( uint znac )
{
if ( rezimWwod ) return;
while ( znac >= 100 ) znac -= 100;
ultoa ( (ulong) znac, bufSim, 10 );
wiwodTekZnc ();
}
//----------------------------------------------------

int invers ( ulong adr, uint mask )
{
uint zncSt, zncMl;
CtenMdk ( adr-0x10, &zncMl );
CtenMdk ( adr, &zncSt );
zncSt ^= mask;
zncSt &= 0x0feff;
ZapisMdk ( adr, zncSt );
ZapisMdk ( adr-0x10, zncMl );
return ( zncSt );
}

void izmZvet ()
{
if ( 0x20 & invers ( 0x0d0300030, 0x20 ))
  invers ( 0x0d0300030, 0x40 );
}

void ishodnoe ()
{
strcpy ( bufSim, "15" );
wiwodTekZnc ();
ZapisMdk ( 0x0d0300030, 0x100 );
ZapisMdk ( 0x0d0300020, 0x1FF );
}

//-----------------------------------------------------------------
/*-----------------------------------------------------------------
 䮭 ..

樮 ࠬ  -  2

㭪樨 ॠ樨  " "
䠩 plan.cpp
ࠧࠡ⪠ 2000 
------------------------------------------------------------------*/

#include"demo.h"

extern uint Kdr;

#include<stdio.h>
#include<conio.h>
#include<string.h>
#include<dos.h>
#include<stdlib.h>
#include<ctype.h>
#include<bios.h>

/*
**---------------------------------------------------------------
**                砫 ᭮ ணࠬ
**---------------------------------------------------------------
*/

struct
{
                float zpu;
                float s;
                float time;
                char name[8];
} PM[10] ={
{244.0,94.0,44580.0,0x20,0x31,0x2D,0xCA,0xC0,0xD0,0xC0,0xD2}, /* 12.23 1- */
{283.0,93.0,45000.0,0x20,0x32,0x2D,0xCC,0xC0,0xD1,0xCA,0xC0}, /* 12.30 2- */
{326.0,95.0,45420.0,0x20,0x34,0x2D,0xD6,0x2E,0xC2,0xCF,0xCF}, /* 12.37 4-. */

{348.0,125.5,46020.0,0xCA,0xC0,0xC2,0xC5,0xD0,0xC8,0xCD,0xCE}, /* 12.47  */
{355.0,250.0,47220.0,0xCB,0xD3,0xCD,0xC8,0xCD,0xCE,0x20,0x20}, /* 13.07  */
{359.0,640.0,50100.0,0xC3,0xCE,0xCB,0xC8,0xD6,0xC8,0xCD,0xCE}, /* 13.55  */
{354.0,496.6,52320.0,0xD1,0xC5,0xD0,0xCD,0xCE,0xC2,0xD1,0xCA}, /* 14.32  */
{358.0,466.6,54420.0,0xCA,0xD0,0xC8,0xD3,0xD8,0xC8,0x20,0x20},  /* 15.07  */

{344.0,120.0,54900.0,0x20,0x31,0x2D,0xCA,0xC0,0xD0,0xD2,0xC0}, /* 15.15 1-TA */
{276.0,40.0, 55080.0,0x20,0x32,0x2D,0xCF,0xCE,0xD0,0xCE,0xC3}, /* 15.18 2- */
};

struct
{
                float time;
                char name[8];
}
AerVzl={44400.0,0xC4,0xDF,0xC3,0xC8,0xCB,0xC5,0xC2,0xCE}, /* 12.20  */
AerPos={55200.0,0xD7,0xC5,0xC1,0xC5,0xCD,0xDC,0xCA,0xC8}; /* 15.20  */

struct
{
                float kurs;
                char vpp[2];
                char name[6];
}
SMV = {244.0,0xCB,0x24,0xCF,0xCE,0xC8,0xD1,0xCA,0}, /* 244  */
SMP = {273.0,0x20,0x27,0xC3,0xD0,0xC0,0xD4,0xC0,0}; /* 273  */

struct
{
                float az;
                float s;
                char name[8];
} ZapAer[3] ={
{205.0, 127.0, 0xCE,0xD0,0xD1,0xCA,0x20,0x20,0x20,0x20}, /*  */
{122.0, 231.0, 0xD3,0xD0,0xC0,0xCB,0xDC,0xD1,0xCA,0x20}, /*  */
{160.0, 453.0, 0xDD,0xCD,0xC3,0xC5,0xCB,0xDC,0xD1,0x20}  /*  */
};

int N=1,ZPU=1;
int Mode=0,Num=0,Fix=0;
/*
**  ନ஢   த஬ ᠤ
*/
void Pos(long unsigned adr)
{
                unsigned int *ptr;
                ptr = (unsigned*)&(AerPos);
                ptr++;

                ZapisMdk(adr+0x10L,0);
                ZapisMdk(adr,0);

                ZapisMdk(adr+0x30L,*ptr); ptr--;
                ZapisMdk(adr+0x20L,*ptr); ptr+=3;

                ZapisMdk(adr+0x50L,*ptr); ptr--;
                ZapisMdk(adr+0x40L,*ptr); ptr+=3;

                ZapisMdk(adr+0x70L,*ptr); ptr--;
                ZapisMdk(adr+0x60L,*ptr);
}

/*
**  ନ஢   ᭮ த஬
*/
void Zap(unsigned long adr, int i)
{
                unsigned int *ptr;
                ptr = (unsigned*)&(ZapAer[i]);
                ptr++;
                ZapisMdk(adr+0x10L,*ptr); ptr--;
                ZapisMdk(adr,*ptr); ptr+=3;
                ZapisMdk(adr+0x30L,*ptr); ptr--;
                ZapisMdk(adr+0x20L,*ptr); ptr+=3;
                ZapisMdk(adr+0x50L,*ptr); ptr--;
                ZapisMdk(adr+0x40L,*ptr); ptr+=3;
                ZapisMdk(adr+0x70L,*ptr); ptr--;
                ZapisMdk(adr+0x60L,*ptr);
}

/*
**  ନ஢   㭪 
*/
void formpm(unsigned long adr, int i)
{
                unsigned int *ptr;
                ptr = (unsigned*)&(PM[i]);
                if (ZPU);
                else     ptr +=2;
                ptr++;
                ZapisMdk(adr+0x10L,*ptr); ptr--;
                ZapisMdk(adr,*ptr); ptr+=3;

                if (ZPU) ptr+=2;

                ZapisMdk(adr+0x30L,*ptr); ptr--;
                ZapisMdk(adr+0x20L,*ptr); ptr+=3;

                ZapisMdk(adr+0x50L,*ptr); ptr--;
                ZapisMdk(adr+0x40L,*ptr); ptr+=3;
                ZapisMdk(adr+0x70L,*ptr); ptr--;
                ZapisMdk(adr+0x60L,*ptr);
}

/*
**  ନ஢    
*/
void formplan(void)
{
                int unsigned w2,w,*ptr;
                ZapisMdk(0xD0300070L,11);
                ZapisMdk(0xD0300060L,N);

                w2 = w = 0;
                if (N>6) w+=((10-N)*2+7);         //  
                if (N<5) w+=(((10-N)*2+7)<<8);    //  
                if (N>3 && N<9) w2+=((10-N)*2+1); //  
                ZapisMdk(0xD0300090L,w2);
                ZapisMdk(0xD0300080L,w);
                switch (Mode)
                {
                case 1:         //  
                                CtenMdk(0xD0300080L,&w);
                                CtenMdk(0xD0300090L,&w2);
                                w2&=0xFF;
                                w2+=(Num*2+5)<<8;
                                ZapisMdk(0xD0300090L,w2);
                                ZapisMdk(0xD0300080L,w);
                                ZapisMdk(0xD03000B0L,0);
                                ZapisMdk(0xD03000A0L,0);
                                break;
                case 2:        //  ࠧ
                                CtenMdk(0xD0300020L,&w);
                                CtenMdk(0xD0300030L,&w2);
                                w2&=0xFFDF;
                                w2|=0x40;
                                if (Fix) w2&=0xFFBF;
                                ZapisMdk(0xD0300030L,w2);
                                ZapisMdk(0xD0300020L,w);

                                CtenMdk(0xD0300080L,&w);
                                CtenMdk(0xD0300090L,&w2);
                                w2&=0xFF;
                                ZapisMdk(0xD0300090L,w2);
                                ZapisMdk(0xD0300080L,w);

                                CtenMdk(0xD03000A0L,&w);
                                CtenMdk(0xD03000B0L,&w2);
                                w=0;
                                w+=(Num*2+5)<<8;
                                ZapisMdk(0xD03000B0L,w2);
                                ZapisMdk(0xD03000A0L,w);
                                break;
                case 3:        // ࠢ ࠧ
                                CtenMdk(0xD0300020L,&w);
                                CtenMdk(0xD0300030L,&w2);
                                w2|=0x20;
                                w2|=0x40;
                                if (Fix) w2&=0xFFBF;
                                ZapisMdk(0xD0300030L,w2);
                                ZapisMdk(0xD0300020L,w);

                                CtenMdk(0xD0300080L,&w);
                                CtenMdk(0xD0300090L,&w2);
                                w2&=0xFF;
                                ZapisMdk(0xD0300090L,w2);
                                ZapisMdk(0xD0300080L,w);

                                CtenMdk(0xD03000A0L,&w);
                                CtenMdk(0xD03000B0L,&w2);
                                w=0;
                                w+=(Num*2+5)<<8;
                                ZapisMdk(0xD03000B0L,w2);
                                ZapisMdk(0xD03000A0L,w);
                                break;
                case 4:        //  
                                CtenMdk(0xD0300020L,&w);
                                CtenMdk(0xD0300030L,&w2);
                                w2|=0x80;
                                if (Fix) w2&=0xFF7F;
                                ZapisMdk(0xD0300030L,w2);
                                ZapisMdk(0xD0300020L,w);

                                CtenMdk(0xD0300080L,&w);
                                CtenMdk(0xD0300090L,&w2);
                                w2&=0xFF;
                                ZapisMdk(0xD0300090L,w2);
                                ZapisMdk(0xD0300080L,w);

                                CtenMdk(0xD03000A0L,&w);
                                CtenMdk(0xD03000B0L,&w2);
                                w=0;
                                w+=(Num*2+5);
                                ZapisMdk(0xD03000B0L,w2);
                                ZapisMdk(0xD03000A0L,w);
                                break;
                default:
                                CtenMdk(0xD0300080L,&w);
                                CtenMdk(0xD0300090L,&w2);
                                w2&=0xFF;
                                ZapisMdk(0xD0300090L,w2);
                                ZapisMdk(0xD0300080L,w);

                                CtenMdk(0xD03000A0L,&w);
                                CtenMdk(0xD03000B0L,&w2);
                                ZapisMdk(0xD03000B0L,w2);
                                ZapisMdk(0xD03000A0L,0);
                                break;
                };
                if (N==11)
                {
                                Pos(0xD0300200L);
                                Zap(0xD0300280L,0);
                                Zap(0xD0300300L,1);
                                Zap(0xD0300380L,2);
                                ZapisMdk(0xD0300450L,0);
                                ZapisMdk(0xD0300440L,0);
                                goto smp;
                }
                formpm(0xD0300200L,N-1);

                if (N==10)
                {
                                Pos(0xD0300280L);
                                Zap(0xD0300300L,0);
                                Zap(0xD0300380L,1);
                                Zap(0xD0300400L,2);
                                goto smp;
                }

                formpm(0xD0300280L,N);

                if (N==9)
                {
                                Pos(0xD0300300L);
                                Zap(0xD0300380L,0);
                                Zap(0xD0300400L,1);
                                goto smp;
                }

                formpm(0xD0300300L,N+1);

                if (N==8)
                {
                                Pos(0xD0300380L);
                                Zap(0xD0300400L,0);
                                goto smp;
                }
                formpm(0xD0300380L,N+2);

                if (N==7)
                {
                                Pos(0xD0300400L);
                                goto smp;
                }

                formpm(0xD0300400L,N+3);

smp:;
                if ((N>3) && (N<8))
                {
                                ptr = (unsigned*)&(SMP);
                                ptr++;
                                ZapisMdk(0xD0300490L,*ptr); ptr--;
                                ZapisMdk(0xD0300480L,*ptr); ptr+=2;

                                ZapisMdk(0xD03004B0L,0);
                                ZapisMdk(0xD03004A0L,*ptr); ptr+=2;

                                ZapisMdk(0xD03004D0L,*ptr); ptr--;
                                ZapisMdk(0xD03004C0L,*ptr); ptr+=3;
                                ZapisMdk(0xD03004F0L,0); ptr--;
                                ZapisMdk(0xD03004E0L,*ptr);
                }
}

/*
**  ନ஢   த஬ 
*/
void InitVzl(void)
{
        unsigned *ptr;
        ptr = (unsigned*)&(AerVzl);
        ptr++;
        ZapisMdk(0xD0300190L,0);
        ZapisMdk(0xD0300180L,0);
        ZapisMdk(0xD03001B0L,*ptr); ptr--;
        ZapisMdk(0xD03001A0L,*ptr); ptr+=3;
        ZapisMdk(0xD03001D0L,*ptr); ptr--;
        ZapisMdk(0xD03001C0L,*ptr); ptr+=3;
        ZapisMdk(0xD03001F0L,*ptr); ptr--;
        ZapisMdk(0xD03001E0L,*ptr);
}

/*
**  ஢ ⥪⮢ 
*/
int NumEd;
void Edit(int n)
{
        char buffer[10];
        unsigned int i,w,w2,asc;
        char cod[26]={
        0xD4,0xC8,0xD1,0xC2,0xD3,0xC0,0xCF,0xD0,0xD8,0xCE,0xCB,0xC4,0xDC,
        0xD2,0xD9,0xC7,0x20,0xCA,0xDB,0xC5,0xC3,0xCC,0xD6,0xD7,0xCD,0xDF};
        if ((n+N) > 16) return; // 室  । 
        if (NumEd!=n)
        {
                NumEd=n;
                CtenMdk(0xD03000A0L,&w);
                CtenMdk(0xD03000B0L,&w2);
                w2=n*2+1;                //  ப
                ZapisMdk(0xD03000B0L,w2);
                ZapisMdk(0xD03000A0L,w);
                return;
        }
        if (n==0) return;
        CtenMdk(0xD0300020L,&w);
        CtenMdk(0xD0300030L,&w2);
        w|=0x200;
        ZapisMdk(0xD0300030L,w2);
        ZapisMdk(0xD0300020L,w);

        /*  ⠥   */
        CtenMdk(0xD0300140L + n*0x80,(uint*)&(buffer[0]));
        CtenMdk(0xD0300150L + n*0x80,(uint*)&(buffer[2]));
        CtenMdk(0xD0300160L + n*0x80,(uint*)&(buffer[4]));
        CtenMdk(0xD0300170L + n*0x80,(uint*)&(buffer[6]));
        i=0;
        while(1)
        {
                CtenMdk(0xD0300020L,&w);
                CtenMdk(0xD0300030L,&w2);
                w&=0xFE00;
                w|=(i+15+n*48); /* न  */
                ZapisMdk(0xD0300030L,w2);
                ZapisMdk(0xD0300020L,w);
                checkZki();

                asc=bioskey(0);
                if ( asc & 0xFF ) asc &= 0x00FF;

                if (asc==13 || asc==27) break;
                if ( (asc>='0' && asc<='9') || (asc>='a' && asc<='z') ||
                         asc==',' || asc=='.' || asc=='/' ||
                         asc==';' || asc=='\'' ||
                         asc=='[' || asc==']' || asc==' ')
                {
                        if (asc>='a' && asc<='z') buffer[i]=cod[asc-'a'];
                        else if (asc>='0' && asc<='9') buffer[i]=asc;
                        else if (asc=='[') buffer[i]=0xD5; /* X */
                        else if (asc==']') buffer[i]=0xDA; /*  */
                        else if (asc==';') buffer[i]=0xC6; /*  */
                        else if (asc=='\'') buffer[i]=0xDD; /*  */
                        else if (asc==',') buffer[i]=0xC1; /*  */
                        else if (asc=='.') buffer[i]=0xDE; /*  */
                        else if (asc=='/') buffer[i]=0x2E; /* . */
                        else if (asc==' ') buffer[i]=0x20; /*   */
                        if (i<7) i++;
                }
                if (asc==0x4D00 && i<7) i++;
                if (asc==0x4B00 && i) i--;
                /* ९  ⮡ࠦ */
                ZapisMdk(0xD0300150L + n*0x80,*((unsigned*)&(buffer[2])));
                ZapisMdk(0xD0300140L + n*0x80,*((unsigned*)&(buffer[0])));
                ZapisMdk(0xD0300170L + n*0x80,*((unsigned*)&(buffer[6])));
                ZapisMdk(0xD0300160L + n*0x80,*((unsigned*)&(buffer[4])));
        }
        if (asc==13) /*   */
        {
                if (n==1) _fmemcpy((char*)&(AerVzl.name),buffer,8);
                else n+=N;
                n--;
                if (n>1 && n<12) _fmemcpy((char*)&(PM[n-2].name),buffer,8);
                else if (n==12) _fmemcpy((char*)&(AerPos.name),buffer,8);
                else if (n>12)  _fmemcpy((char*)&(ZapAer[n-13].name),buffer,8);
        }
        if (asc==27 && n==1) InitVzl(); // ⪠  
        CtenMdk(0xD0300020L,&w);
        CtenMdk(0xD0300030L,&w2);
        w&=0xC000;
        w|=0x1FF;   //  
        ZapisMdk(0xD0300030L,w2);
        ZapisMdk(0xD0300020L,w);
}
/*
**  楤 ᬥ ० 蠬 
*/
void ChMode(int i)
{
        if (Num!=i) Mode=0;
        if (Mode<4) Mode++;
        else Mode=0;
        Num=i;
        Fix=0;
}

void plan(void)
{
                int unsigned w,w2,*ptr,asc;

                ZapisMdk(0xD0300010L,0x4000);
                ZapisMdk(0xD0300000L,0);
                ZapisMdk(0xD0300030L,0);
                ZapisMdk(0xD0300020L,0x1FF);
                ZapisMdk(0xD0300050L,0);
                ZapisMdk(0xD0300040L,0);

           // ନ஢  
                ptr = (unsigned*)&(SMV.kurs);
                ptr++;
                ZapisMdk(0xD0300110L,*ptr); ptr--;
                ZapisMdk(0xD0300100L,*ptr); ptr+=2;

                ZapisMdk(0xD0300130L,0);
                ZapisMdk(0xD0300120L,*ptr); ptr+=2;

                ZapisMdk(0xD0300150L,*ptr); ptr--;
                ZapisMdk(0xD0300140L,*ptr); ptr+=3;
                ZapisMdk(0xD0300170L,0); ptr--;
                ZapisMdk(0xD0300160L,*ptr);

                InitVzl();
                NumEd=0;
                Edit(3);

                Kdr=26;
                formplan();
                checkZki();
                while(asc!=27)
                {
                                asc=bioskey(0);
                                if ( asc & 0xFF ) asc &= 0x00FF;

                                if (asc==0x4800 && N>1)
                                {
                                                N--;
                                                Fix=Mode=0;
//                                              if (NumEd) NumEd--;
                                                Edit(0);
                                }
                                if (asc==0x5000 && N<11)
                                {
                                                N++;
                                                Fix=Mode=0;
//                                              if (NumEd) NumEd++;
//                                              if (NumEd==7) NumEd=0;
                                                Edit(0);
                                }
                                if (asc==0x3B00)
                                {
                                                CtenMdk(0xD0300000L,&w);
                                                CtenMdk(0xD0300010L,&w2);
                                                w2^=0x4000;
                                                ZapisMdk(0xD0300010L,w2);
                                                ZapisMdk(0xD0300000L,w);
                                }
                                if (asc==0x3D00)
                                {
                                                CtenMdk(0xD0300020L,&w);
                                                CtenMdk(0xD0300030L,&w2);
                                                w2^=0x10;
                                                ZPU =(! ZPU);
                                                ZapisMdk(0xD0300030L,w2);
                                                ZapisMdk(0xD0300020L,w);
                                }
                                if (asc==0x3F00 && N<11) ChMode(1);
                                if (asc==0x4100 && N<10) ChMode(2);
                                if (asc==0x4300 && N<9) ChMode(3);
                                if (asc=='`' && N<8) ChMode(4);

                                if (asc==13 && (Mode==2 || Mode==3 || Mode==4)) Fix=1;

                                if (asc==0x3c00) Edit(1);
                                if (asc==0x3e00) Edit(2);
                                if (asc==0x4000) Edit(3);
                                if (asc==0x4200) Edit(4);
                                if (asc==0x4400) Edit(5);
                                if (asc=='\\')  Edit(6);
                                formplan();
                                checkZki();
                }
}

/*-----------------------------------------------------------------
 ਭ ..

樮 ࠬ  -  2

⥪ ࠢ ⠩஬
䠩 Tmr.cpp
ࠧࠡ⪠ 2000 
------------------------------------------------------------------*/

#include <dos.h>
#include <bios.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "demo.h"
#include "mww.h"


void interrupt (* dosTimer )(...);
int	timerRabotaet = 0;
int volatile flagPrer = 0;
float DeltaTmr = 0;
float tekWrem = 0;
int shProp = 0;
int Count = 0;
int CasDelit = 0;
int CasConst = 0;

void stopTimer ()
{
if ( timerRabotaet )
  {
  asm	cli
  asm	mov	al,0x36      /*      00 11 011 0*/
  asm	out     0x43,al
  asm	mov	al,0xFF
  asm	out     0x40,al
  asm	mov	al,0xFF
  asm	out     0x40,al
//  asm	sti
  setvect ( 8, dosTimer );
  timerRabotaet = 0;
  }
}

float posWrem;

void interrupt funTimer (...)
{
tekWrem += DeltaTmr;

if ( flagPrer ) shProp++;
else
  {
  flagPrer = 1;

  if ( tekWrem - posWrem > 1000 )
	{
	posWrem = tekWrem;
	uint wrmi = posWrem / 1000;
	uint otvMww = ObmenMww ( wrmi );
	avtKren ( otvMww );
	StorozTmrMww ();
	checkZki ();
	}
  flagPrer = 0;
  }

Count++;
if ( !( Count & CasDelit ) ) dosTimer ();
else
  {
  asm	mov	al,20h
  asm	out	20h,al
  //asm	sti
  }
}

#define kolUcTmrDinam 8
char masCasConst [ kolUcTmrDinam ] = { 0377, 0177, 0077, 0037, 0017, 0007, 0003, 0001 };
char masCasDelit [ kolUcTmrDinam ] = { 0000, 0001, 0003, 0007, 0017, 0037, 0077, 0177 };
float masDeltaTmr [ kolUcTmrDinam ] = { 54.9255, 27.4627, 13.7314, 6.8657, 3.4328, 1.7164, 0.8582, 0.4291 };

void initTimer ()
{
if ( timerRabotaet ) stopTimer ();

CasConst = masCasConst [ 0 ];
CasDelit = masCasDelit [ 0 ];
DeltaTmr = masDeltaTmr [ 0 ];
dosTimer = getvect ( 8 );
setvect ( 8, funTimer );

asm	cli
asm	mov	al,0x36      /*      00 11 011 0*/
asm	out     0x43,al
asm	mov	al,0xFF
asm	out     0x40,al
_AL = CasConst;
asm	out     0x40,al
Count = 0L;

//asm	sti

timerRabotaet = 1;
}



/*-----------------------------------------------------------------
 ਭ ..

樮 ࠬ  -  2

  -34
䠩 ObmenMww.cpp
ࠧࠡ⪠ 2000 
------------------------------------------------------------------*/

#include <stdio.h>
#include <bios.h>
#include <dos.h>
#include <stdlib.h>
#include <io.h>
#include <FCNTL.H>
#include <SYS\STAT.h>
#include <string.h>

#include "demo.h"
#include "mww.h"

//  㭪樨    ᥬ, ⥭    寮⮢ 
//     0 - ଠ,  -  訡 (   mww.h )

//   ᮬ  訥 16 ࠧ冷,     

//㭪  ᥬ

uint OpenSf ( uint nSf )
{
uint ret,scet = 0,status = 1;
if ( nSf > 7 ) return ERR_OTL;
ulong adrSf = 0xA08000l + ( nSf << 1 );
ret = ZapisExt ( adrSf, 0 );
while ((status!=0) && (scet++<100) && ( !ret )) ret = CtenExt ( adrSf, &status );
if ( !ret ) if ( status ) ret = ERR_NOOPENSF;
return ret;
}

//㭪  ᥬ
uint CloseSf ( uint nSf )
{
if ( nSf > 7 ) return ERR_OTL;
return ZapisExt ( 0xA08000l+(nSf<<1), 1 );
}

//㭪   2- ⮢  १ ᥬ
uint ZapisMwwInt ( uint nSf, uint adr, uint znc )
{
uint ret = OpenSf ( nSf );
if ( !ret ) ret = ZapisExt ( BASADR+adr, znc );
if ( !ret ) CloseSf ( nSf );
return ret;
}

//㭪 ⥭  2- ⮢  १ ᥬ
uint CtenMwwInt ( uint nSf, uint adr, uint* znc )
{
uint ret = OpenSf ( nSf );
if ( !ret ) ret = CtenExt ( BASADR+adr, znc );
if ( !ret ) ret = CloseSf ( nSf );
return ret;
}

uint ZapisMwwLng ( uint nSf, uint adr, ulong znc )
{
ulong adrExt = BASADR + adr;
uint ret = OpenSf ( nSf );
if ( !ret ) ret = ZapisExtV ( adrExt, &znc, 4 );
if ( !ret ) CloseSf ( nSf );
return ret;
}

uint CtenMwwLng ( uint nSf, uint adr, ulong* znc )
{
ulong adrExt = BASADR + adr;
uint ret = OpenSf ( nSf );
if ( !ret ) ret = CtenExtV ( adrExt, znc, 4 );
if ( !ret ) ret = CloseSf ( nSf );
return ret;
}

//--------------------------------------------------------
// ᯮ⥫ 㭪樨  뢮 ᮮ饭  ࠭  १ printf

char* ImaRezimMww ( uint rezim )
{
switch ( rezim )
  {
  case SS_OBMEN : return "";
  case SS_OZIDANIE : return "";
  case SS_INIT : return "ᮧ  ";
  case SS_RASKON : return "७ ஫";
  case SS_KPP : return "";
  case SS_KONTOBM : return "஫  ";
  }
return "";
}

char* ImaErr ( uint err )
{
switch ( err )
  {
  case NO_ERR : return "訡 ";
  case ERR_OTL : return "४   ணࠬ";
  case ERR_PUST : return " ";
  case ERR_KSUM : return "ᮮ⢥⢨ ஫쭮 㬬";
  case ERR_NOOPENSF : return " 뢠 ᥬ";
  case ERR_EXT : return " 㯠  ७ ";
  case ERR_NETOTVET : return "ࠢ쭠 ॠ ";
  case ERR_PUSTGR : return "㯯  ᮤন ᨣ";
  case ERR_ODINAK_KOORD : return " ᨣ  묨 न⠬";
  case ERR_DLINA : return "᫨誮  㯯 ᨣ";
  case ERR_FILE : return " 뢠 䠩";
  case ERR_ADR : return "⨬  ";
  case ERR_NOPRER : return " 뢠";
  case ERR_NOTMR : return " 뢠  ⠩";
  case ERR_NOINIT : return "砫   樠樨";
  case ERR_NOPRDKLS : return " ᢮ । ।  ";
  case ERR_NOPRMKLS : return " ᢮ । ਥ  ";
  case ERR_LINIA : return "⨬  ";
  case ERR_NEPRREZ : return "⨬  ० ";
  }
return " 訡";
}

//  뢭 ஫ 㭪樮஢ 
//  ᪠  ⠩ (  㭪樨 funTimer 䠩 tmr.cpp )

uint zapSlSostMww = 0;
uint zapStTmrMww = 0;
uint zapRetMww = NO_ERR;
uint zapNeObnMww = 1;
uint flagPrerMww = 0;

uint StorozTmrMww ()
{
uint slSostMww;
uint slIspMww;
uint stTmrMww;
uint neObnMww;

if ( flagPrerMww )
  {
  printf ( "諮 %d 뢠  \n", flagPrerMww );
  flagPrerMww = 0;
  }

uint ret = OpenSf ( SF_STORTMR );

if ( ! ret ) ret = CtenMwwInt ( 7, SL_SOST, &slSostMww );
if ( ! ret ) if ( slSostMww != zapSlSostMww )
  {
  zapSlSostMww = slSostMww;
  printf (" ﭨ  : ");
  if ( slSostMww & ( SS_NI_MWW | SS_NI_OBM ))
	{
	if ( slSostMww & SS_NI_MWW ) printf ("⪠ : ");
	if ( slSostMww & SS_NI_OBM ) printf ("४ : ");
	ret = CtenMwwInt ( 7, SL_ISPR_TIP, &slIspMww );
	printf ( "%s", ImaErr ( slIspMww ));
	}
  else printf ( "ࠢ" );
  printf ( ", ० ࠡ: <%s>\n", ImaRezimMww ( slSostMww & SS_REZIM ));
  }
if ( ! ret ) ret = CtenMwwInt ( 7, SL_TMR2, &stTmrMww );
if ( ! ret )
  {
  if ( stTmrMww != zapStTmrMww )
	{
	if ( ! zapNeObnMww )
	  {
	  printf (
	  "   ஦ ⠩ %d %d\n",
	  zapStTmrMww, stTmrMww );
	  zapNeObnMww = 1;
	  }
	}
  else
	{
	if ( zapNeObnMww )
	  {
	  printf ( " 砫  ஦ ⠩\n" );
	  zapNeObnMww = 0;
	  }
	}
  }
zapStTmrMww ++;
if ( !ret ) ret = ZapisMwwInt ( 7, SL_TMR1, zapStTmrMww );

CloseSf ( SF_STORTMR );

if ( ret != zapRetMww )
  {
  if ( ret ) printf ( " 㯠  : - %s ( %x )\n", ImaErr ( ret ), ret );
  else printf ( "   \n" );
  zapRetMww = ret;
  }
return ret;
}

// ࠡ稪 뢠  

void interrupt ObrabotkaPrerMww (...)
{
//asm cli;
uint slSost;
CtenMwwInt ( 7, SL_SOST, &slSost );
printf ( "諮 뢠   :  ﭨ %x\n", slSost );
flagPrerMww ++;

asm	mov	al,20h
asm	out	0A0h,al

//asm	sti
}

//-----------------------------------------------------------
//  ६ ⫠筠 ணࠬ  ਮ᪮ 뢮  ࠭
//  祥 ୮ 
//  ᪠  ⠩ (  㭪樨 funTimer 䠩 tmr.cpp )

int scetStrok = -1;

uint ObmenMww ( uint zncZap )
{
uint zncCten, retZap, retCten;
uint  q4, q6, q8, qus, qss, qt1, qt2;
ulong  qa, q400, q500, q600;

ulong lngZap = zncZap;
lngZap <<= 20;
lngZap += zncZap;
retZap = ZapisMwwLng ( 7, 0x200, lngZap );
retZap = ZapisMwwLng ( 7, 0x104, 0x10400104l );
retZap = ZapisMwwLng ( 7, 0x108, 0x10800108l );
retZap = ZapisMwwLng ( 7, 0x10c, 0x10c0010cl );
retZap = ZapisMwwLng ( 7, 0x110, 0x11000110l );

CtenMwwInt ( 7, 2, &zncCten );
CtenMwwInt ( 7, 4, &q4 );
CtenMwwInt ( 7, 6, &q6 );
CtenMwwInt ( 7, 8, &q8 );
CtenMwwLng ( 7, 0xa, &qa );
CtenMwwLng ( 7, 0x400, &q400 );
CtenMwwLng ( 7, 0x500, &q500 );
CtenMwwLng ( 7, 0x600, &q600 );
CtenMwwInt ( 7, SL_UPR, &qus );
CtenMwwInt ( 7, SL_SOST, &qss );
CtenMwwInt ( 7, SL_TMR1, &qt1 );
CtenMwwInt ( 7, SL_TMR2, &qt2 );

if ( zncZap == 10 ) ZapisMwwLng ( 7, 0x600, 0 );

if ( scetStrok++ > 20 ) scetStrok = 0;
if ( ! scetStrok )
  {
  printf ("-------------------------------------------------------------------------------\n");
  printf (". . 4    6    8        a       400      500      600     㤠 \n");
  printf ("-------------------------------------------------------------------------------\n");
  }
printf ("%4x %4x  %4x %4x %4x %8lx  %8lx %8lx %8lx %4x %4x\n",
  qus,qss, q4,q6,q8,qa, q400,q500,q600,qt1,qt2);
return zncCten;
}

/*-----------------------------------------------------------------
 ਭ ..

樮 ࠬ  -  2

樠 -34
䠩 InitMww.cpp
ࠧࠡ⪠ 2000 
------------------------------------------------------------------*/

#include <stdio.h>
#include <bios.h>
#include <dos.h>
#include <stdlib.h>
#include <io.h>
#include <FCNTL.H>
#include <SYS\STAT.h>
#include <string.h>

#include "demo.h"
#include "mww.h"
extern uint flagPrerMww;

// ॢ   ॡ㥬 ०  ஫ ॠ樨 

uint RezimMww ( uint trebRezim )
{
uint ret = NO_ERR;
uint rezMww = 1;
uint scet = 20000;
while (( rezMww != trebRezim ) && ( !ret ) && scet )
  {
  ret = CtenMwwInt ( 7, SL_SOST, &rezMww );  // ⠥ ᫮ ﭨ
  rezMww &= SS_REZIM;
  if ( rezMww != trebRezim )              // ᫨ ०   -
	{                                     // 뢠    ᫮
	if ( !ret ) ret = ZapisMwwInt ( 7, SL_UPR, trebRezim );
	scet --;
	}
  }
if (( rezMww != trebRezim ) && ( !ret ))
  {
  printf ( "  ॢ  ० <%s> \n ( ⮨  <%s> (%x) )\n",
	ImaRezimMww ( trebRezim ), ImaRezimMww ( rezMww ), rezMww );
  return ERR_NETOTVET;
  }
if ( ret ) printf ( "訡 㯠   - %s ( %x ))\n", ImaErr ( ret ), ret );
else printf ( " ॢ  ० <%s> \n", ImaRezimMww ( trebRezim ));
return ret;
}

uint OzidanieOtvetaMww ( uint trebRezim, uint timeout )
{
uint ret = NO_ERR;
uint rezMww = 1;
uint ss;
uint scet = timeout;
while (( rezMww != trebRezim ) && ( !ret ) && scet )
  {
  ret = CtenMwwInt ( 7, SL_SOST, &ss );  // ⠥ ᫮ ﭨ
  rezMww = ss & SS_REZIM;
  delay ( 1000 );
  scet --;
  }
if (( rezMww != trebRezim ) && ( !ret ))
  {
  printf ( "  襫  ० <%s> \n ( ⮨  <%s> (%x) )\n",
	ImaRezimMww ( trebRezim ), ImaRezimMww ( rezMww ), rezMww );
  return ERR_NETOTVET;
  }
if ( ret ) printf ( "訡 㯠   - %s )\n", ImaErr ( ret ));
else printf ( " 襫  ० <%s> \n", ImaRezimMww ( trebRezim ));

if ( ! ret ) if ( ss & ( SS_NI_MWW | SS_NI_OBM ))
  {
  if ( ss & SS_NI_MWW ) printf ( "䨪஢ ⪠  " );
  if ( ss & SS_NI_OBM ) printf ( "䨪஢ ⪠    " );
  uint isT = ERR_NETOTVET, isA = 0, isP1 = 0, isP2 = 0;
  if ( ! ret ) ret = CtenMwwInt ( 7, SL_ISPR_TIP, &isT );
  if ( ! ret ) ret = CtenMwwInt ( 7, SL_ISPR_ADR, &isA );
  if ( ! ret ) ret = CtenMwwInt ( 7, SL_ISPR_PAR1, &isP1 );
  if ( ! ret ) ret = CtenMwwInt ( 7, SL_ISPR_PAR2, &isP2 );
  printf ( " 稭 < %s > ( %x %x %x )\n",
    ImaErr ( isT ), isA, isP1, isP2 );
  if ( ! ret ) ret = isT;
  }

return ret;
}

//-----------------------------------------------------------
//  樠   
//  㭪 ᪠  ࠧ  砫 ࠡ
// (  㭪樨 main 䠩 demo.cpp )

uint InitObmenMww ()
{
for ( int j = 0; j < 10; j++ )
  for ( int i = 0; i <= 7; i++ ) CloseSf ( i );

flagPrerMww = 0;
/*							// 樠 뢠
setvect ( 0x72, ObrabotkaPrerMww );
//asm	IN AL,a1h
//_AL &= 0xfb;
_AL = 0;
asm	OUT 0a1h,AL  // ࠧ襭 뢠 
//asm sti
//ZapisExt ( 0xa14000, 0 ); // ࠧ襭 뢠 
*/
uint ret = ERR_PUST;
uint scet = 3;
while ( ret && scet )
  {
  						   // ॢ  ० 
  ret = RezimMww ( SS_OZIDANIE );
						   // ᫨ 襫 - ஫  
//  if ( ! ret ) ret = RezimMww ( SS_KONTOBM );
//  if ( ! ret ) ret = KontMww ();
                           // ᫨ ᡮ  - ७ ஫
//  if ( ! ret ) ret = RezimMww ( SS_RASKON );
//  if ( ! ret ) ret = RasKont ();
				   // ᫨ ᡮ  - ᮧ   .⮢ 
  if ( ! ret ) ret = RezimMww ( SS_OZIDANIE );
  if ( ! ret ) ret = FormBdMww ();
					   //  ॢ   ० ⥭ 
  if ( ! ret ) ret = RezimMww ( SS_INIT );
  if ( ! ret ) ret = OzidanieOtvetaMww ( SS_OZIDANIE, 20 );
						   // ᫨  㦥 - 
  if ( ! ret ) ret = RezimMww ( SS_OBMEN );

  scet --;
  }

if ( ! ret ) printf ( "樠  ந ᯥ譮\n");
else printf ( "樠   襭 ( %s )\n", ImaErr ( ret ));

return ret;
}

//------------------------------------------------------------
//     

uint tekGr, tekSg, kolGr = 0;
uint tekAdr = 0x40;
#define maxGr 8
uint tekInitAdr = 0x60;
char imaFil [ 200 ];
ulong sum = 0;

uint FormBdMww ()
{
imaFil [ 0 ] = 0;
printf ( "ନ஢   :\n  -  㦭           - 0\n  -             - 1\n  -  䠩 e:\\bd.mww - 2\n  -  㣮 䠩   -  䠩\n    ?" );
scanf ( "%s", imaFil );
switch ( imaFil [ 0 ] )
  {
  case 0: return ERR_OTL;
  case '0': return NO_ERR;
  case '1': return ZaprosBdRucn ();
  case '2': strcpy ( imaFil, "e:\\bd.mww" );
  }

int hFil = open ( imaFil, O_CREAT|O_RDWR, S_IREAD|S_IWRITE);
if ( ! hFil )
  {
  printf ( " 뢠 䠩 %s \n", imaFil );
  return ERR_FILE;
  }
uint buf;
printf ( "⥭  䠩 %s ( %d )", imaFil, hFil );
uint tekAdr = 0x40;
do
  {
  read ( hFil, &buf, 2 );
  ZapisMwwInt ( 7, tekAdr, buf );
  tekAdr += 2;
  }
while ( ! eof ( hFil ));

tekAdr -= 2;
printf ( "襭.   Ox%x\n", tekAdr );
close ( hFil );
if ( tekAdr == 0x40 ) return ERR_FILE;
return NO_ERR;
}

uint ZaprosBdRucn ()
{
uint ret = NO_ERR;
for ( int i = 0; i < maxGr; i++ )
  {
  if ( ! ret ) ret = ZapisMwwInt ( 7, 0x40 + ( i << 1 ), 0 );
  }
printf ( "⢮ 㯯 ᨣ ? " ); scanf ("%d", &kolGr );
if ( kolGr > maxGr ) kolGr = maxGr;
for ( tekGr = 0; tekGr < kolGr; tekGr++ )
  {
  struct TGrSign gr;
  if ( ! ret ) ret = ZaprosGrSign ( &gr );
  sum = KonSum ( &gr, LEN_GR );
  if ( ! ret )
    {
    ret = ZapisExtV ( BASADR + 0x40 + ( tekGr << 1 ), &tekInitAdr ,2 );
    ret = ZapisExtV ( BASADR + tekInitAdr, &gr ,LEN_GR );
    tekInitAdr += LEN_GR;
    }
  if ( gr.kolvo ) for ( tekSg = 0; tekSg < gr.kolvo; tekSg++ )
    {
    struct TSign sg;
    if ( ! ret ) ret = ZaprosSign ( &sg );
    sum += KonSum ( &sg, LEN_SIGN );
    if ( ! ret )
      {
      ret = ZapisExtV ( BASADR + tekInitAdr, &sg ,LEN_SIGN );
      tekInitAdr += LEN_SIGN;
      }
    printf ( "\n" );
    }
  if ( ! ret )
    {
    printf ( "஫쭠 㬬 让 㯯 = %lx\n", sum );
    ret = ZapisExtV ( BASADR + tekInitAdr, &sum ,LEN_KS );
    printf ( " = %lx\n", sum );

    tekInitAdr += LEN_KS;
    }
  }

printf ( "࠭  䠩   ( ஡ -  㦭 ) ?");
  scanf ( "%s", imaFil );
if ( imaFil [ 0 ] != ' ' )
  {
  int hFil = open ( imaFil, O_CREAT|O_RDWR|O_TRUNC, S_IWRITE );
  if ( ! hFil )
    {
    printf ( " 뢠 䠩 %s\n", imaFil );
    return ERR_FILE;
    }
  uint len = tekInitAdr - 0x40 + 2;
  if ( len )
    {
    printf ( "  䠩 %s  %d\n", imaFil, len );
    char buf [ 1000 ];
    CtenExtV ( BASADR + 0x40, &buf, len );
    write ( hFil, &buf, len );
    }
  close ( hFil );
  }
return ret;
}

uint ZaprosGrSign ( struct TGrSign* gr )
{
if ( ! gr ) return ERR_OTL;

printf ( " %d 㯯 ᨣ  ।  \n", tekGr );

printf ( "  ਥ - 0  । - 1 ?" ); scanf ( "%d", &(gr->prd) );
if ( gr->prd > 1 ) gr->prd = 1;
if ( ! gr->prd )
  {
  printf ( "  뢠   - 1   - 0 ?" ); scanf ( "%d", &gr->ss );
  if ( gr->ss > 1 ) gr->ss = 1;
  }
else gr->ss = 0;
printf ( "  ਮ  ?" ); scanf ( "%d", &gr->period );
printf ( "  ⢮ ᨣ ?" ); scanf ( "%d", &gr->kolvo );
printf ( "   ᨢ 祭 ? 0x" ); scanf ( "%x", &gr->adrZnac );
if ( ! gr->prd )
  {
  printf ( "   ᨢ  ( 1 - /   0 -  㦥 ) ? 0x" ); scanf ( "%x", &gr->adrMatr );
  printf ( "   ᨢ 䫠 ( 0 -  㦥 ) ? 0x" ); scanf ( "%x", &gr->adrFlag );
  }
else gr->adrMatr = gr->adrFlag = 0;
return NO_ERR;
}

uint ZaprosSign ( struct TSign* sg )
{
if ( ! sg ) return ERR_OTL;

printf ( "   %d ᨣ\n", tekSg );

int z;
printf ( "     ?" ); scanf ( "%d", &z );
if ( z > 31 ) z = 31;
sg -> kanal = z;

printf ( "       ?" ); scanf ( "%d", &z );
if ( z > 255 ) z &= 0xff;
sg -> adrKls = z;

printf ( "     . ࠧ鸞 ( 0 - ⮢  ) ?" );
  scanf ( "%f", &(sg -> csr) );

return NO_ERR;
}

ulong KonSum ( void* gr, uint len )
{
uchar* tek = ( uchar* ) gr;
ulong sum = 0l;
for ( int i = 0; i < len; i++ )
  {
  sum += (ulong)*tek;
  printf ( "tek = %4x  *tek = %2x  sum = %8lx\n", tek, *tek, sum );
  tek ++;
  }
printf ( "஫쭠 㬬 㯯 = %lx\n", sum);
return sum;
}

