;                      MLib.inc
;                   09/02/99 10:43
TxD       = ACOM          ;  ॣ஢ COM1,2
RxD       = ACOM
BaudRateL = ACOM
BaudRateH = ACOM+1
IntrEn    = ACOM+1
LnCtrl    = ACOM+3
MdmCtrl   = ACOM+4
LnStatus  = ACOM+5
MdmStatus = ACOM+6

OutPB  MACRO   A,V,B
           MOV     DX,A
         IFB     <B>
           MOV     AL,V
         ELSE
           IN      AL,DX
           OR      AL,V
         ENDIF
           OUT     DX,AL
       ENDM
;
WTRdy  MACRO        ;  ⮢  ।
LOCAL   L1,L2
        MOV     DX, LnStatus
L1:     IN      AL,DX
        TEST    AL,40h
        JZ      L1
        OutPB   MdmCtrl,1
        MOV     DX, MdmStatus
L2:     IN      AL,DX
        AND     AL,30h
        XOR     AL,30h
        JNZ     L2
        OutPB   MdmCtrl,3
      ENDM
TxHex  MACRO        ; । 16-. 
LOCAL  L
        CMP     AL,10
        JS      L
        ADD     AL,7
L:      ADD     AL,48
        MOV     DX,TxD
        OUT     DX,AL
      ENDM
OutChr MACRO   ch
LOCAL   L
        MOV     DX, LnStatus
L:      IN      AL,DX
        TEST    AL,40h
        JZ      L
        MOV     AL,ch
        MOV     DX,TxD
        OUT     DX,AL
      ENDM
;
WTRdy1  MACRO        ;  ⮢  ।
LOCAL   L
        MOV     DX, LnStatus
L:      IN      AL,DX
        TEST    AL,40h
        JZ      L
      ENDM
;
WtLn   MACRO        ;  ⮢  ।
LOCAL   L1,L2,L3
        MOV     DX, LnStatus   ;- 
L1:     IN      AL,DX          ;-  ⮢
        AND     AL,5Fh         ;-  ।稪
        JZ      L1             ;-
        CMP     AL,40h         ;-
        JZ      L3             ;-
        MOV     AH,AL       ;-
        TEST    AH,1        ;- ஢ઠ
        JZ      L2          ;-   "⬥"
        MOV     DX, RxD     ;-
        IN      AL,DX       ;-
L2:
        AND     AH,1Eh    ;-  訡 ?
        JNZ     RcErr     ;-
        CMP     AL,'C'
        JE      AcknC
        MOV     AH,20h    ;- ⨬
        JMP     RcErr     ;-   
L3:
      ENDM
;
WtCTS    MACRO       ;   ।
LOCAL   L
        OutPB   MdmCtrl,1     ; DTR:=1, RTS:=0
        MOV     DX, MdmStatus
L:      IN      AL,DX
        AND     AL,30h
        XOR     AL,30h
        JNZ     L
        OutPB   MdmCtrl,3         ; DTR := 1, RTS := 1
      ENDM
;
RcByte  MACRO        ; ਥ 
LOCAL   L1,L2,L3
L1:     MOV     DX, MdmStatus
	IN      AL,DX
	AND     AL,30h
	XOR     AL,30h
	JZ      L2
	OutPB   MdmCtrl,1   ; DTR:=1, RTS:=0
	JMP     L1
L2:     OutPB   MdmCtrl,3   ; DTR:=1, RTS:=1
	MOV     DX, LnStatus
	IN      AL,DX
	AND     AL,1Fh
	JZ      L1
	MOV     AH,AL
	TEST    AH,1
	JZ      L3
	MOV     DX, RxD
	IN      AL,DX
L3:     AND     AH,1Eh
	JNZ     RcErr
      ENDM
;
SetVect MACRO   t,adr
        MOV     DI,t SHL 2
        MOV     AX,OFFSET adr
        STOSW
        MOV     [ES:DI],CS
      ENDM
;
P1Cfg  = 0F820h     ;  ॣ஢ 䨣樨
P2Cfg  = 0F822h
P3Cfg  = 0F824h
PinCfg = 0F826h
DMACfg = 0F830h
IntCfg = 0F832h
SIOCfg = 0F836h
;
TmrCfg = 0F834h         ; ॣ ⠩
ClkPrs = 0F804h
TmrCon =  0043h
Tmr2   =  0042h
Tmr0   =  0040h
WDTStatus = 0F4CAh      ; ஦ ⠩
;
PICm0  = 020h           ;  ஫
PICm1  = 021h           ;    뢠
PICs0  = 0A0h           ;
PICs1  = 0A1h           ;
;
IRq0t  = 60h            ;  
IRq8t  = 70h            ;    뢠 IRq
IRx1_8t   = 65h         ;
IRx9_16t  = 66h         ;
IRx17_24t = 67h         ;
IRx25_32t = 70h         ;
ITx1_3t   = 71h         ;
ITx4_6t   = 75h         ;
ITx7_9t   = 76h         ;
;
P1Ltc  = 0F862h         ;
P1Dir  = 0F864h         ;
P2Ltc  = 0F86Ah         ;
P2Dir  = 0F86Ch         ;
P2Pin  = 0F868h         ; - ࠫ. 
P3Pin  = 0F870h         ;
;
RgBST  = 0FF00h          ; -FF01h  ஫
;                   MRT
MRT_SelfTest EQU <GS:[BP+086h]>
MRT_Status  EQU  <WORD PTR GS:[BP+080h]>
MRT_Mask    EQU  <WORD PTR GS:[BP+082h]>
MRT_RxCtrl  EQU  <BYTE PTR GS:[BP+DI+1]>
MRT_RxGap   EQU  <BYTE PTR GS:[BP+DI+2]>
MRT_RxMSW   EQU  <WORD PTR GS:[BP+DI+4]>
MRT_RxLSW   EQU  <WORD PTR GS:[BP+DI+6]>
MRT_TxCtrl  EQU  <WORD PTR GS:[BP+DI+040h]>
MRT_TxFreq  EQU  <BYTE PTR GS:[BP+DI+042h]>
MRT_TxMSW   EQU  <WORD PTR GS:[BP+DI+044h]>
MRT_TxLSW   EQU  <WORD PTR GS:[BP+DI+046h]>
MRT_LCM     EQU  <BYTE PTR GS:[BP+DI+200h]>
