/*--------------------------------------------------------------------
 ਭ ..

 -34 
.00225-01

    ࠢ 
䠩 Init.cpp
ࠧࠡ⪠ 2000 
---------------------------------------------------------------------*/

#include "SpoMww.h"

extern uint niObmen, niMww, flagInit;

char ispLinPrm [ MAX_PRM ];
char ispLinPrd [ MAX_PRD ];

struct TGrSign grSign [ MAX_GR ];
struct TSign sg;
int kolicGrupp = 0;

ulong sumEtalon;
int tekAdr;
uint tekNacSg;

uint adr;
int nGr,nSg,kol;

uint UstIspLin ( uint prd, uint linia )
//-----------------
{
if ( prd )
  {
  if ( linia > MAX_PRD ) return ERR_LINIA;
  ispLinPrd [ linia ] ++;
  }
else
  {
  if ( linia > MAX_PRM ) return ERR_LINIA;
  ispLinPrm [ linia ] ++;
  }
return NO_ERR;
}

uint SoobErr ( uint tipErr, uint adr, uint par1, uint par2 )
//-------------
{
ZapisMpr ( 4, 0 );
ZapisMpr ( SL_ISPR_TIP, tipErr );
ZapisMpr ( SL_ISPR_ADR, adr );
ZapisMpr ( SL_ISPR_PAR1, par1 );
ZapisMpr ( SL_ISPR_PAR2, par2 );
ZapisMpr ( SL_UPR, SS_OZIDANIE );
return niObmen = flagInit = tipErr;
}

ulong iSum;
uchar iFlg;

static uint zA, z2;
static uint* z1;

uint RezimInit ()
//====================
{
uint ret = NO_ERR;
adr = 0x40;
tekNacSg = 0;
InitFlag ();
ZapisMpr ( 4, 0x101 );
for ( nGr = 0; nGr < MAX_PRM; nGr++ ) ispLinPrm [ nGr ] = 0;
for ( nGr = 0; nGr < MAX_PRD; nGr++ ) ispLinPrd [ nGr ] = 0;

for ( nGr = 0; nGr < MAX_GR; nGr++ )
  {
  grSign [ nGr ]. kolvo = 0;
  }
for ( nGr = 0; nGr < MAX_GR; nGr++ ) if ( ! ret )
  {
  CtenMpr ( adr, &tekAdr );
  if ( tekAdr )
    {
    kolicGrupp = nGr;
    if ( ! ret ) ret = CtenMprV ( tekAdr, &grSign[nGr], LEN_GR );
    iSum = KonSum ( &grSign[nGr], LEN_GR );
    tekAdr += LEN_GR;

    kol = grSign[nGr].kolvo;
    if ( kol > MAX_SGGR )
      return SoobErr ( ERR_DLINA, nGr, kol, MAX_SGGR );

    grSign[nGr].nacSg = tekNacSg;

    if ( kol ) for ( nSg = 0; nSg < kol; nSg++ )
      {
      if ( ! ret ) ret = CtenMprV ( tekAdr, &sg, LEN_SIGN );
      iFlg = Flag ( grSign[nGr].prd, sg.koord );
      if ( iFlg ) return SoobErr ( ERR_ODINAK_KOORD, nGr, sg.koord, iFlg );

      UstFlag ( grSign[nGr].prd, sg.koord, F_ISP );

      ZapisKoord ( tekNacSg++, (uint*) &sg );

      if ( UstIspLin ( grSign[nGr].prd, sg.koord >> 8 ))
        return SoobErr ( ERR_LINIA, nGr, sg.koord, 0 );

      if ( grSign[nGr].prd )
        ispLinPrd [ sg.koord >> 8 ] ++;
      else ispLinPrm [ sg.koord >> 8 ] ++;
      iSum += KonSum ( &sg, LEN_SIGN );
      tekAdr += LEN_SIGN;
      }
    CtenMprV ( tekAdr, &sumEtalon, LEN_KS );
    tekAdr += LEN_KS;

    if ( sumEtalon != iSum )
      return SoobErr ( ERR_KSUM, nGr, iSum & 0xffff, sumEtalon & 0xffff );
    }
  else grSign [ nGr ]. kolvo = 0;
  adr += 2;
  }
if ( !ret ) ret = initKls ();

niObmen = ret;
ZapisMpr ( SL_UPR, SS_OZIDANIE );
flagInit = ret;
return ret;
}

uchar* tek;
ulong tSum;
int ti;
uint tLen;

ulong KonSum ( void* gr, uint len )
{
tLen = len;
tek = ( uchar* ) gr;
tSum = 0L;
for ( ti = 0; ti < tLen; ti++ )
  {
  tSum += *tek;
  tek++;
  }
return tSum;
}

