/*--------------------------------------------------------------------
 ਭ ..

 -34 
.00225-01

㭪樨   
䠩 ObmKls.cpp
ࠧࠡ⪠ 2000 
---------------------------------------------------------------------*/
#include "SpoMww.h"


extern char ispLinPrm [ MAX_PRM ];
extern char ispLinPrd [ MAX_PRD ];

uint BasKlsPrd [ MAX_PRD ];
uint BasKlsPrm [ MAX_PRM ];

uint ilShema, ilNomer;

void ZapisRegKls ( uint smes, uint znac )
{
asm    mov   ax, 5000h
asm    mov   es, ax
_AX = smes;
asm    mov   si, ax
asm    mov   ax, es:si
_AX = znac;
asm    mov   es:si, ax
}

uint RegKls ( uint smes )
{
asm    mov   ax, 5000h
asm    mov   es, ax
_AX = smes;
asm    mov   si, ax
asm    mov   ax, es:si
return _AX;
}

//*************************************************************

uint ikLin, ikReg, ikAdr;

uint initKls ()
//---------------
{
BasKlsPrd [ 0 ] = 0x040;
BasKlsPrd [ 1 ] = 0x048;
BasKlsPrd [ 2 ] = 0x050;
BasKlsPrd [ 3 ] = 0x440;
BasKlsPrd [ 4 ] = 0x448;
BasKlsPrd [ 5 ] = 0x450;
BasKlsPrd [ 6 ] = 0x840;
BasKlsPrd [ 7 ] = 0x848;
BasKlsPrd [ 8 ] = 0x850;

BasKlsPrm [  0 ] = 0x000;
BasKlsPrm [  1 ] = 0x008;
BasKlsPrm [  2 ] = 0x010;
BasKlsPrm [  3 ] = 0x018;
BasKlsPrm [  4 ] = 0x020;
BasKlsPrm [  5 ] = 0x028;
BasKlsPrm [  6 ] = 0x030;
BasKlsPrm [  7 ] = 0x038;
BasKlsPrm [  8 ] = 0x400;
BasKlsPrm [  9 ] = 0x408;
BasKlsPrm [ 10 ] = 0x410;
BasKlsPrm [ 11 ] = 0x418;
BasKlsPrm [ 12 ] = 0x420;
BasKlsPrm [ 13 ] = 0x428;
BasKlsPrm [ 14 ] = 0x430;
BasKlsPrm [ 15 ] = 0x438;
BasKlsPrm [ 16 ] = 0x800;
BasKlsPrm [ 17 ] = 0x808;
BasKlsPrm [ 18 ] = 0x810;
BasKlsPrm [ 19 ] = 0x818;
BasKlsPrm [ 20 ] = 0x820;
BasKlsPrm [ 21 ] = 0x828;
BasKlsPrm [ 22 ] = 0x830;
BasKlsPrm [ 23 ] = 0x838;
BasKlsPrm [ 24 ] = 0xc00;
BasKlsPrm [ 25 ] = 0xc08;
BasKlsPrm [ 26 ] = 0xc10;
BasKlsPrm [ 27 ] = 0xc18;
BasKlsPrm [ 28 ] = 0xc20;
BasKlsPrm [ 29 ] = 0xc28;
BasKlsPrm [ 30 ] = 0xc30;
BasKlsPrm [ 31 ] = 0xc38;

for ( ikLin = 0; ikLin < MAX_PRM; ikLin++ )
  {
  ikAdr = BasKlsPrm [ ikLin ];
  if ( ispLinPrm [ ikLin ] )
    {
    ZapisRegKls ( ikAdr + 2, 40 );
    ZapisRegKls ( ikAdr, 0x8000 );
    }
  else ZapisRegKls ( ikAdr, 0 );
  }
for ( ikLin = 0; ikLin < MAX_PRD; ikLin++ )
  {
  ikAdr = BasKlsPrd [ ikLin ];
  if ( ispLinPrd [ ikLin ] )
    {
    ikReg = RegKls ( ikAdr );
    ikReg &= 0x1f;
    ZapisRegKls ( ikAdr, ikReg );
    ikReg |= 0x10;
    ZapisRegKls ( ikAdr, ikReg );

    ZapisRegKls ( ikAdr + 2, 20 );

    ikReg |= 0x280;
    ZapisRegKls ( ikAdr, ikReg );
//    ikReg |= 0xc00;
//    ZapisRegKls ( ikAdr, ikReg );
    ikReg |= 0x8000;
    ZapisRegKls ( ikAdr, ikReg );
    }
  else
    {
    ZapisRegKls ( ikAdr, 0x10 );
    ZapisRegKls ( ikAdr, 0 );
    }
  }
return NO_ERR;
}

//**************************************************************

uint ocSmes, ocReg, ocTmp, ocScet;

uint Ocered ( uint linia )
{
ocSmes = BasKlsPrd [ linia ];
ocReg = 0; ocScet = 0xff;
while (( ! ocReg ) && ( ocScet ))
  {
  ocReg = RegKls ( ocSmes );
  ocReg &= 0xf;

  if ( ! ocReg )
    {
    if ( ! ( ocScet & 0xcf ))
      {
      ocTmp = RegKls ( ocSmes );
      ocTmp &= 0x10;
      ZapisRegKls ( ocSmes, ocTmp );
      }
    else if ( ocScet == 4 )
      {
      ocTmp = RegKls ( ocSmes );
      ocTmp |= 0x8000;
      ZapisRegKls ( ocSmes, ocTmp );
      ocTmp &= 0x7fff;
      ZapisRegKls ( ocSmes, ocTmp );
      }
    }
  }
return ( ocReg ? NO_ERR : ERR_NOPRDKLS );
}


uint zkZnSt, zkZnMl, zkSmSt, zkSmMl;

uint ZapisKls ( uint linia, ulong znac )
//---------------------------------------
{
if ( linia >= MAX_PRD ) return ERR_OTL;
if ( Ocered ( linia ) ) return ERR_NOPRDKLS;
zkSmMl = BasKlsPrd [ linia ] + 4;
zkSmSt = zkSmMl + 2;

zkZnMl = znac & 0xffff;
zkZnSt = ( znac >> 16 ) & 0xffff;

ZapisRegKls ( zkSmMl, zkZnMl );
ZapisRegKls ( zkSmSt, zkZnSt );
return NO_ERR;
}

static uint mkLin, mkAdr, mkKoord, mkSmes, mkScet;
static uint mkRet, mkFlag;
uint MwwKls ()
//-----------------
{
mkRet = NO_ERR;
for ( mkAdr = 0; mkAdr < MAX_SG; mkAdr ++ )
  for ( mkLin = 0; mkLin < MAX_PRD; mkLin ++ )
  {
  mkKoord = ( mkLin << 8 ) + mkAdr;
  mkFlag = Flag ( N_PRD, mkKoord );
  if ( mkFlag & FR_OBN )
    {
    if ( ! ( mkFlag & ( FB_ZAP | F_ZANT )))
      {
      UstFlag ( N_PRD, mkKoord, FZ_FON );
      if ( ! mkRet ) mkRet = ZapisKls ( mkLin, Data ( N_PRD, mkKoord ));
      SbrosFlag ( N_PRD, mkKoord, F_ZANT | F_REZIM );
      }
    }
  }
return mkRet;
}

//******************************************************************

uint eiRS, eiMask, eiZnac;

uint EstInf ( uint linia )
{
eiRS = 0x80 + (( linia & 0x18 ) << 7 );
eiMask = 1 << ( linia & 0x7 );

eiZnac = RegKls ( eiRS );
eiZnac &= eiMask;

return eiZnac;
}

uint ckZnSt, ckZnMl, ckSmSt, ckSmMl;
ulong ckZnac;

uint CtenKls ( uint linia, ulong* znac )
{
if ( linia  > MAX_PRM ) return ERR_OTL;
if ( ! EstInf ( linia ))
  {
//  ZapisMprSoob ( 0x201, linia, 0, 0 );
  return ERR_PUST;
  }
//ZapisMprSoob ( 0x202, linia, 0, 0 );

ckSmMl = BasKlsPrm [ linia ] + 4;
ckSmSt = ckSmMl + 2;

ckZnMl = RegKls ( ckSmMl );
ckZnSt = RegKls ( ckSmSt );
ckZnac = ckZnSt;
ckZnac <<= 16;
ckZnac += ckZnMl;
*znac = ckZnac;

//ZapisMprSoob ( 0x203, linia, ckSmMl, ckZnac );

return NO_ERR;
}

ulong kmZnac, kmStar;
uint kmObn, kmEst, kmLin, kmKoord, kmStarFlag, kmScet;
uint kmNewFlag;

uint KlsMww ()
{
//ZapisMprSoob ( 0x101, kmLin, kmEst, kmZnac );
for ( kmLin = 0; kmLin < MAX_PRM; kmLin++ )
  {
  kmScet = ispLinPrm [ kmLin ];
  kmObn = 2;
  while ( kmObn && ( kmScet -- ))
    {
    kmObn = 0;
    kmEst = CtenKls ( kmLin, &kmZnac );
    if ( ! kmEst )
      {
      //ZapisMprSoob ( 0x102, kmLin, kmKoord, kmZnac );
      kmObn = 1;
      kmKoord = ( kmZnac & 0xff ) + ( kmLin << 8 );
      kmStar = Data ( N_PRM, kmKoord );
      kmStarFlag = Flag ( N_PRM, kmKoord );
      if ( kmZnac != kmStar )
        {
        ZapisData ( N_PRM, kmKoord, kmZnac );
        UstFlag ( N_PRM, kmKoord, FR_IZM );
        }
      else if ( ! (  kmStarFlag & FR_IZM ))
        UstFlag ( N_PRM, kmKoord, FR_OBN );

      kmNewFlag = Flag ( N_PRM, kmKoord );
      //ZapisMprSoob ( 0x103, kmKoord, kmStarFlag, kmZnac );
      }
    else if ( kmEst != ERR_PUST ) return kmEst;
    }
  }
return NO_ERR;
}
