/*--------------------------------------------------------------------
 ਭ ..

 -34 
.00225-01

 ।
䠩 SpoMww.h
ࠧࠡ⪠ 2000 
---------------------------------------------------------------------*/

//  ⨯ ६

#define uint unsigned int
#define ulong unsigned long
#define uchar unsigned char

//  ⨯ 訡

#define NO_ERR 0
#define ERR_OTL 1
#define ERR_PUST 2
#define ERR_KSUM 10
#define ERR_NOOPENSF 11
#define ERR_EXT 12
#define ERR_NETOTVET 13
#define ERR_PUSTGR 14
#define ERR_FILE 15
#define ERR_ODINAK_KOORD 16
#define ERR_ADR 17
#define ERR_DLINA 18
#define ERR_NOTMR 19
#define ERR_NOPRER 20
#define ERR_NOINIT 21
#define ERR_NOPRDKLS 22
#define ERR_NOPRMKLS 23
#define ERR_LINIA 24
#define ERR_NEPRREZ 25

//  ⭮⥫  寮⮢ 

#define ADR_MAS_NASTR 0x40
#define SL_TMR_MWW 0x7fee
#define SL_ISPR_TIP 0x7ff0
#define SL_ISPR_ADR 0x7ff2
#define SL_ISPR_PAR1 0x7ff4
#define SL_ISPR_PAR2 0x7ff6
#define SL_TMR1 0x7ff8
#define SL_TMR2 0x7ffa
#define SL_SOST 0x7ffc
#define SL_UPR 0x7ffe

//  ࠧ冷 ࠢ饣 ᫮  ᫮ ﭨ

#define SS_REZIM 0x1f00
#define SS_OBMEN 0
#define SS_OZIDANIE 0x100
#define SS_INIT 0x200
#define SS_RASKON 0x400
#define SS_KPP 0x800
#define SS_KONTOBM 0x1000

#define SS_NI_MWW 0x8000
#define SS_NI_OBM 0x4000

#define SF_STORTMR 7

//  祭 䫠

#define N_PRD 1
#define N_PRM 0

#define F_ISP 0x01

#define F_ZANT 0x0e
#define FZ_TEHN 0x02
#define FZ_FON 0x04
#define FZ_TMR 0x08

#define F_REZIM 0x30
#define FR_OBN 0x10
#define FR_IZM 0x20

#define F_BLOK 0xc0
#define FB_CTEN 0x40
#define FB_ZAP 0x80

//  ୮ ᨢ
#define MAX_ALL_SIGN 20

#define MAX_GR 8
#define MAX_PRM 32
#define MAX_PRD 9
#define MAX_SG 256

#define MAX_SGGR 32  //ᨬ쭮 ⢮ ᨣ  㯯

// ᠭ   ᨣ  㯯 ᨣ
// ਭ   樠樨

struct TSign
{
//uchar kanal;
//uchar adrKls;
uint koord;
long csr; // float
};
#define LEN_SIGN 6

struct TGrSign
{
public:
uchar prd;
uchar ss;
uint period;
uint kolvo;
uint adrZnac;
uint adrMatr;
uint adrFlag;
//  ⮫쪮  
int scet;
uint nacSg;
};
#define LEN_GR 12
#define LEN_KS 4

// 㭪樨 䠩 upr.cpp

void Cikl ();
uint IzmRezim ();
uint RezimOzidan ();

void initTmr ();
void interrupt obrTmr ();

// 㭪樨 䠩 ObmMpr.cpp

void Pause ();
uint OpenSf ( uint nSf );
uint CloseSf ( uint nSf );
uint CtenMprSf ( uint nSf, uint adr, int* znc );
uint ZapisMprSf ( uint nSf, uint adr, int znc );
void CtenMpr ( uint adr, int* znc );
void ZapisMpr ( uint adr, int znc );
uint CtenMprV ( uint adr, void* znc, uint len );
uint ZapisMprV ( uint adr, void* znc, uint len );
void ZapisMprSoob ( uint z4, uint z6, uint z8, ulong za );

uint StorozTmr ( uint ret );

uint ObmenMpr ();

uint MprMww ( uint nGr );
uint MwwMpr ( uint nGr );
uint RezimObmen ();

// 㭪樨 䠩 ObmKls.cpp

uint initKls ();
uint KlsMww ();
uint MwwKls ();
uint RegKls (uint smes);
void ZapisRegKls ( uint smes, uint znac );
uint CtenKls ( uint linia, ulong* znac );
uint ZapisKls ( uint linia, ulong znac );

// 㭪樨 䠩 Init.cpp

uint SoobErr ( uint tipErr, uint adr, uint par1, uint par2 );
uint RezimInit ();
ulong KonSum ( void* adr, uint len );

// 㭪樨 䠩 Massiv.cpp

ulong Data ( uchar prd, uint koord );
void ZapisData ( uchar prd, uint koord, ulong znc );
uchar Flag ( uchar prd, uint koord );
//void ZapisFlag ( uchar prd, uint koord, uchar znc );
void UstFlag ( uchar prd, uint koord, uchar znc );
void SbrosFlag ( uchar prd, uint koord, uchar znc );
void InitFlag ();
uint Koord ( uint nSg );
void ZapisKoord ( uint nSg, uint* znc );

// 㭪樨 䠩 KontObm.cpp

void SetOK ();       //OK
void SetError ();    //ERROR
void KontObm (int upr_sl);
uint RezimKontObm ();

// 㭪樨 䠩 raskont.cpp

uint RasKont ();
uint Chip_Test ();              // ய
uint Flash_Test ();             // 
uint Ram_Test();                //  
uint Ext_Ram_Test();            //७  
uint Signal_Otkaz_Mww_Test();   // ᨣ "⪠ "
uint Kontrol_Kls_Test();        // ஫ 

// 㭪樨 䠩 float.cpp

long Fto24L ( long flt, long csr );  // float ->  ( 業 .. - float )
long L24toF ( long lng, long csr );  //  -> float ( 業 .. - float )

